Bargraph

Symbol:

Description:

This function block is used to refer to a bar graph in a HMI.

The input bShow is used to show or hide the HMI object. And the value that shall be displayed is assigned to iPos.

HMI Object:

The HMI object displays a horizontal or vertical bar graph, depending on the aspect ratio. If the width is equal or greater than the height a horizontal bar graph is provided. Otherwise the bar graph is vertical. At horizontal bar graphs the values rise from left to right. And the scale is displayed above the bar. The highest value of vertical bar graphs is at the top and the lowest at the bottom. In this case the scale is on the left side of the bar.

Parameter:

In the parameter dialog a bargraph HMI object is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The visibility and the colors of the several elements are configured in the parameter dialog of the object. Furthermore the minimum and maximum values and the dividing of the scale are adjusted.

Signals:

Name

I/O

Type(s)

Function

iPos

I

WORD

Input value

bShow

I

BIT

Show / hide object

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.

Visualization:

The colored highlight in the function block indicates, whether a HMI object is assigned or not.


Bitmap

Symbol:

Description:

This function block is used to refer to a bitmap to be displayed in a HMI.

The input bShow is used to show or hide the HMI object. A language specific bitmap resource (see mask designer) is assigned to the object via iLang and iBmp. Finally the background color is set at lBGClr.

HMI Object:

The HMI object displays a previously defined bitmap resource.

Parameter:

In the parameter dialog a bitmap HMI object is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The default settings for the bitmap resource and the background color are specified in the parameter dialog of the object. Furthermore the horizontal and vertical alignment of the bitmap is defined.

Signals:

Name

I/O

Type(s)

Function

iBmp

I

WORD

Bitmap resource (ID)

bShow

I

BIT

Show / hide object

iLang

I

WORD

Language resource (ID)

lBGClr

I

LONG

Background color

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.


Bitmap Button / Switch

Symbol:

Description:

This function block is used to refer to a button or switch in a HMI, which is able to display a bitmap.

The input bShow is used to show or hide the HMI object. It is enabled with a HIGH signal on the input bEnable and disabled with a LOW signal. The inputs iENBmp, iEPBmp, iDNBmp and iDPBmp are used to assign background bitmaps for the button states “normal”, “pressed”, “disabled” and “disabled + pressed”. A label is assigned via the inputs iText or sText. With iText a language specific text resource is selected. The plain text that is connected to sText is displayed if iText is not connected or the parameter value “undefined” is assigned to it. The language of the used bitmap and text resources is specified at input iLang.

Depending on the type selection in the parameter dialog the pressing of the button or the state of the switch is written to the output bPress. If the type is “Button (signal on button down)” or “Button (signal on button up)” then the output bPress changes for one program cycle from LOW to HIGH after the button is pressed. If the object is a switch then HIGH is output in the states “pressed” and “disabled + pressed”. In the other states LOW is written to bPress.

HMI Object:

The HMI-object displays a button or a switch. It can be labeled with a text and state dependent background bitmaps. If the alignment is set to “Bitmap and Text centred” then large pictures can conceal the edges of the button. Other shapes can be easily assigned with the help of this feature. e.g. flat buttons or check boxes.

Parameter:

In the parameter dialog a HMI object of the type “Bitmap Button / Switch” is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The type selection in the parameter dialog of the object determines whether the object is a button or a switch. A button is only pressed as long as the mouse button is pressed. The button returns to normal state when the mouse button is released. A switch persists after the first pressing in the state “pressed” and changes only after another use back to normal state. Furthermore two button types are distinguished. One writes an edge to the output of the function block when the button is pressed and the other when it is released.

The state dependent background and text colors, the font as well as the default values for the bitmaps and the texts and their alignment are configured in the parameter dialog. A language specific text resource or a plain text can be assigned to label the button.

Signals:

Name

I/O

Type(s)

Function

sText

I

TEXT, DYNTEXT

Plain text

iText

I

WORD

Text resource (ID)

iEPBmp

I

WORD

Bitmap resource (ID) – pressed

iENBmp

I

WORD

Bitmap resource (ID) – normal

iDPBmp

I

WORD

Bitmap resource (ID) – disabled + pressed

iDNBmp

I

WORD

Bitmap resource (ID) – disabled

bShow

I

BIT

Show / hide object

bEnable

I

BIT

Enable / disable

iLang

I

WORD

Language resource (ID)

bPress

O

BIT

Button pressed or switch state

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.


Button

Symbol:

Description:

This function block is used to refer to a button in a HMI, which can be labeled with a text.

The input bShow is used to show or hide the HMI object. It is enabled with a HIGH signal on the input bEnable and disabled with a LOW signal. The inputs iLang, iText and sText are used to label the button. A language specific text resource (see mask designer) is selected with iLang and iText. The plain text that is connected to sText is displayed if iText is not connected or the parameter value “undefined” is assigned to it.

After pressing the button the output bPress changes for one program cycle from LOW to HIGH.

HMI Object:

The HMI object displays a button with a black horizontally and vertically centered label.

Parameter:

In the parameter dialog a HMI object of the type “Button (unicode)” is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The font and the default values for the label and the activation state are set in the parameter dialog of the object. A language specific text resource or a plain text can be assigned to label it.

Signals:

Name

I/O

Type(s)

Function

sText

I

TEXT, DYNTEXT

Plain text

iText

I

WORD

Text resource (ID)

bShow

I

BIT

Show / hide object

bEnable

I

BIT

Enable / disable

iLang

I

WORD

Language resource (ID)

bPress

O

BIT

Button pressed

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.


LED

Symbol:

Description:

This function block is used to refer to a LED in a HMI, which is a simple graphical object able to be displayed in a selected color.

The input bShow is used to show or hide the HMI-object. Via bOn the status of the LED is set. The LED is switched on with a HIGH signal. The belonging color is defined at the input lOnClr. Is a LOW signal written to bOn, then the LED is switched off and it is displayed with the color that is connected with lOffClr.

HMI Object:

The HMI object displays a rectangular, triangular or round LED. It can be switched between two selected colors.

Parameter:

In the parameter dialog a LED HMI object is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The shape and the default values for the colors are defined in the parameter dialog of the object.

Signals:

Name

I/O

Type(s)

Function

bOn

I

BIT

Control signal

bShow

I

BIT

Hide / show object

lOnClr

I

LONG

Color of the switched on LED

lOffClr

I

LONG

Color of the switched off LED

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.


List Box

Symbol:

Description:

This function block is used to refer to a list box in a HMI, which allows the user to select an element form the listed content.

The input bShow is used to show or hide the HMI object. It is enabled with a HIGH signal on the input bEnable and disabled with a LOW signal. The inputs bSelect and IIndex are used to select a list element. If a HIGH signal is connected with bSelect then IIndex determines the position of the selected element. No element is selected when an invalid index is written to IIndex. A LOW-HIGH edge at the inputs bUp and bDown scrolls the list page by page up and down. A HIGH signal is written to the outputs bUpEnab or bDwEnab when it is possible to scroll in the corresponding direction.

The inputs iNBmp, iSBmp, iText, sText and IData are used to create new or change the existing list elements. The first element of each vector that is connected with one of these inputs configures a feature of the first list element. And the second elements of the vectors define the second list element and so on. The bitmaps for not selected list elements are set at input iNBmp. And the vector that is connected with iSBmp defines the bitmaps of the selected elements. The labels are specified at the inputs iText and sText. And the vector at IData contains the data for the list elements. If a HIGH signal is written to bSet then the settings in the vectors are assigned. The existing list elements will be changed or new ones will be added. The number of list elements after the assignment corresponds to the minimum length of the connected vectors. If some inputs are not connected then the values of the predefined elements or default values are used. Resource texts prevail over plain texts and combinations of data and plain texts, i.e. if a resource ID different to “not defined” is assigned then the corresponding resource text is displayed.

The language of the bitmap and text resources is set at input iLang. The index of the selected element is written to OIndex. If no element is selected then -1 is output. The data of the selected element are provided at OData. The length of the output is limited to 17 characters.

HMI Object:

The HMI object displays a vertical list with single element selection. Two bitmaps for the states “selected” and “not selected” as well as a text can be assigned to every list element.

Parameter:

In the parameter dialog a HMI object of the type “List Box (unicode)” is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The parameter dialog of the object consists of two views. The tabs in the upper left corner are used to switch between the views.

The global settings for the HMI-object and the list elements are entered in the view “General”. The frame and the background color of the list box as well as the default value for the language and the font for the text outputs belong to them. Different background colors can be assigned to selected and not selected list elements. Not only selections but also an enabled or disabled list box can be highlighted with the text color. The default values for the alignment of the bitmaps and texts as well as for the display of data and plain texts are used to uniformly configure all predefined elements. This settings will also be used when further elements are added to the list via the function block. The height of the elements is specified in pixels. After activating the option “Adjust the object height” the list box is shortened to a multiple of the height of the elements. The other option is used to disable the list box.

The second view contains the predefined elements. The context menu provides commands for the adding of new elements as well as the editing, deleting, selecting and moving of existing ones.

The definition of the single elements happens in its own dialog. The index of the list element is specified after “Item-ID”. The first element gets the index 0. The option “highlighted” is used to select the element. Furthermore the two bitmaps, a text and a data string can be assigned. The element can be labeled with a resource text, a plain text or a combination of data and plain text. If a resource text is specified then it will be output. The plain text or a combination of data and plain text are only displayed if the resource text is set to “not defined”. The output of the plain text and the data is configured in the “Display” setting. Every list element can get its own alignment and display parameter. The global parameter will be used if “default” is chosen. Then all elements can be uniformly formatted.

Signals:

Name

I/O

Type(s)

Function

sText

I

TEXT

Plain text vector for labeling the elements

iText

I

WORD

Text resource vector (ID) for labeling the elements

iData

I

WORD

Data vector for the elements

iSBmp

I

WORD

Bitmap resource vector (ID) for selected elements

iNBmp

I

WORD

Bitmap resource vector (ID) for not selected elements

IIndex

I

WORD

Index of the element that is to select

bSelect

I

BIT

Select the entry IIndex

bShow

I

BIT

Show / hide object

bEnable

I

BIT

Enable / disable

iLang

I

WORD

Language resource (ID)

bSet

I

BIT

Set the element definitions

bUp

I

BIT

Scroll upwards

bDown

I

BIT

Scroll downwards

OIndex

O

WORD

Index of the selected element

OData

O

TEXT

Data of the selected element

bUpEnab

O

BIT

State for scroll up

bDwEnab

O

BIT

State for scroll down

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.

Visualization:

The colored highlight in the function block indicates, whether a HMI object is assigned or not.

Comment:

The index of the elements starts always with 0.


Mask

Symbol:

Description:

This function block is used to refer to a mask in a HMI that defines an area serving as background for other objects.

The input bShow is used to show or hide the mask. The background color and a language specific bitmap resource can be set via the inputs lBGClr or iLang and iBmp. The background picture is so arranged that top left corners of the mask and the bitmap suit.

The output bPress changes for one program cycle from LOW to HIGH after clicking the mask or an inserted object that does not process user inputs or is disabled.

The input idParen and the output idMask are used to change the mask hierarchy. The identification number of the mask that is assigned to the function block is provided at output idMask. If it is connected with the input idParen of a second mask block then the mask of the second function block becomes a child of the mask of the first block. It should be taken into account that the display area of child masks is limited to the size of the parent mask and that children are only displayed when the parents are visible.

The inputs bShow and idParen have no effect on the background window. This is a special mask that is always visible and the parent of all other masks.

HMI Mask:

The HMI mask is a rectangular area that contains other objects and masks. It is used to create different views for the HMI.

Parameter:

In the parameter dialog a HMI mask is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI mask. Furthermore the preferences of the HMI mask can be set with the help of the mask designer.

The parameter dialog of the mask can be used to define the default values for the background color and the language and bitmap resource IDs.

Signals:

Name

I/O

Type(s)

Function

idParent

I

WORD

Parent mask (ID)

iBmp

I

WORD

Bitmap resource (ID)

bShow

I

BIT

Show / hide object

iLang

I

WORD

Language resource (ID)

lBGClr

I

LONG

Background color

idMask

O

WORD

Mask (ID)

bPress

O

BIT

Click signal

Note: If inputs are not connected the mask appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting in the parameter dialog.

Visualization:

The colored highlight in the function block indicates, whether a HMI mask is assigned or not.


Numerc Input

HMI Masks and Objects

Numeric Input

Symbol:

Description:

This function block is used to refer to an input object for numeric values in a HMI.

The input bShow is used to show or hide numeric input line. The language of the font and text resources that have been selected in the parameter dialog is set at iLang. If a HIGH signal is written to bSet then the input value that is connected to IValue is checked and assigned to the object. The input value is cut at the first invalid character or format error.

The current value of the numeric input line is written to the output OValue. The changing of the current value is signaled with an edge at the output bChange. The changes can be caused by the user as well as by the setting of another value with help of the inputs bSet and IValue.

HMI Object:

The HMI object displays the left aligned current value in an input line. A modal dialog is opened in the center of the display after the input line has been clicked. Depending on the configuration the modal input dialog is simple or complex.

The simple dialog consists of a line, the number keys, optional keys for the sign and the decimal point and the OK button. After opening the dialog the line is empty. The handling is similar to a calculator. The sign can be changed at any time. The dialog is moved with help of the caption. And the contained button is used to cancel the input.

The complex dialog displays the current value after opening. The value can be deleted character by character with the back key. Or it can be completely removed with the clear key. Because of the missing caption the dialog can't be moved. An additional key is provided to cancel the input.

Parameter:

In the parameter dialog a HMI object of the type “Numeric Input” is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The parameter dialog is divided in three sections.

Global settings for the input line as well as for the modal dialog are entered in the section “General”. The initial value and the default value for the language can be specified there. The other parameters determine the length and the range of values. They influence the checking of input values. And they affect the visibility of the keys for the sign and decimal point in the dialog.

The frame type, the colors and the font of the HMI-object are configured in the section “Input line”.

The third section contains the settings for the modal dialog. The type as well as the font for the line and the keys, their colors and the resource texts for the labels are entered there. The size of the line and the keys is calculated on the basis of the selected font and the assigned labels. And the dialog is automatically adapted. Furthermore a timeout can be defined. If the specified time has elapsed after the last pressing of a key or the opening then the input is automatically canceled. And the dialog is closed.

Signals:

Name

I/O

Type(s)

Function

IValue

I

TEXT

Presetting value

bShow

I

BIT

Show / hide object

iLang

I

WORD

Language resource (ID)

bSet

I

BIT

Set IValue

OValue

O

TEXT

Current value

bChange

O

BIT

Current value has been changed

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.

Visualization:

The colored highlight in the function block indicates, whether a HMI object is assigned or not.

Comment:

The function block operates only with the data type TEXT for the values. To be able to use numeric data types converter function blocks from the adapter library have to be used.


Slider

Symbol:

Description:

This function block is used to refer to a slider in a HMI, where the user can manipulate an input value.

The input bShow is used to show or hide the HMI object. It is enabled or disabled via the input bEnable. If a HIGH signal is connected to the input bSet the value at IPos is checked and the slider is repositioned to the next valid value.

The current position of the slider is provided at the output OPos.

HMI Object:

The HMI object displays a horizontal, from left to right running or a vertical, from top to bottom running slider. The alignment depends on the aspect ratio. If the width is equal or greater than the height a horizontal slider is provided. Otherwise the slider is vertical. The scale of horizontal sliders is below the stylized lever. At vertical sliders it is on the left side.

The position of the slider is changed by dragging the lever or clicking to any point in the HMI object. When a scale is available the positions can be limited to the tics.

Parameter:

In the parameter dialog a slider HMI object is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

Besides the minimum and maximum values and the default value for the position also the activation state and graphic attributes are adjusted in the parameter dialog of the object. The background can be transparent or filled with a color. Furthermore the object can be framed with black lines. Or it can be raised or recessed.

The slider can contain a scale. The number of the tics and their color are entered in the parameter dialog. A dividing is valid when every tic marks a valid WORD value.

Signals:

Name

I/O

Type(s)

Function

IPos

I

WORD

Presetting value

bShow

I

BIT

Show / hide object

bEnable

I

BIT

Enable / disable

bSet

I

BIT

Set IPos

OPos

O

WORD

Current value

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.


Text

Symbol:

Description:

This function block is used to refer to a text displayed in a HMI.

The object is displayed with a HIGH signal on the input bShow and hidden with a LOW signal. The inputs iLang, iText and sText are used to label the object. A language specific text resource (see mask designer) is selected with iLang and iText. The plain text that is connected to sText is displayed if iText is not connected or the parameter value “undefined” is assigned to it. lFGClr and lBGClr define the foreground and background colors.

HMI Object:

The HMI object displays a text, which is either given as a plain text or as a text resource.

Parameter:

In the parameter dialog a HMI object of the type “Text (unicode)” is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The font and the default values for the label and the colors are set in the parameter dialog of the object. A language specific text resource or a plain text can be assigned to it. Furthermore the alignment of the text can be adjusted.

Signals:

Name

I/O

Type(s)

Function

sText

I

TEXT, DYNTEXT

Plain text

iText

I

WORD

Text resource (ID)

bShow

I

BIT

Show / hide object

iLang

I

WORD

Language resource (ID)

lBGClr

I

LONG

Background color

lFGClr

I

LONG

Text color

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.


Trend

Symbol:

Description:

This function block is used to refer to a trend writer in a HMI.

The input bShow is used to show or hide the HMI object. The update of the display is controlled with bUpdate. If the input is not connected then the display is redrawn automatically when the time corresponding to a pixel has passed. Therefore the display changes very often at small time resolutions. That makes it more difficult to watch the signal courses and increases the processor load. The update rate is reduced by connecting a periodical bit signal (e.g. from a clock generator). Then the HMI object is only redrawn when a HIGH signal is connected to bUpdate and at least the time corresponding to a pixel has passed since the last update.

The input signal Values is used to provide the input data to be displayed. The trend writer displays up to 8 curves. Therefore a vector can be connected, but only the first 8 vector elements are used for the trend display. Additional vector elements are ignored. The minimum and the maximum of the vertical scale are set via YMin and YMax. The time resolution in seconds is provided via the input fResolu. It corresponds with the period of the time that is displayed by the horizontal scale.

HMI Object:

The HMI object displays the temporal course of up to 8 signals.

Parameter:

In the parameter dialog a trend writer HMI object is assigned to the function block.

Using the context menu of the function block the mask designer can be invoked as the parameter dialog. The mask designer is used to create the assignment to the HMI object. Now the preferences of the HMI object can be set with the help of the mask designer.

The colors of the different elements as well as the font for the scale values are defined in the parameter dialog. The object becomes transparent by deactivating the background and the draw field. Furthermore the position, the range of values and the dividing of both scales are assigned in the dialog. The settings for the main tics determine also the position of the grid lines that can be deactivated too. Values between 0.1 and 999.999 seconds can be entered for the time resolution.

The HMI object uses a ring buffer to save the displayed signal values together with a time stamp. The length of the X-axis determines the needed amount of memory if automatic buffer size is configured. In this case the buffer contains twice as many elements as the X-axis consists of pixels. Alternatively the buffer size can be assigned manually. The ring buffer covers always the time interval that is displayed on the X-axis. So the buffer size defines the number of the sampling points for the curves. At short cycle times the ring buffer can be too small to keep all input values. Therefore the minimum and the maximum of the input values are saved for every sampling point in the buffer. This method leads at small buffers to the display of two line courses per signal that describe the envelope of the input values. The vertical connections between the courses of maximum and minimum indicate then the sampling points.

Signals:

Name

I/O

Type(s)

Function

Values

I

FLOAT, DOUBLE, UCHAR, WORD, LONG; LONGLONG

Input values

YMax

I

FLOAT, DOUBLE, UCHAR, WORD, LONG; LONGLONG

Maximum of the Y-scale

YMin

I

FLOAT, DOUBLE, UCHAR, WORD, LONG; LONGLONG

Minimum of the Y-scale

fResolu

I

FLOAT

Time resolution in second

bShow

I

BIT

Show / hide object

bUpdate

I

BIT

Update the trend display

Note: If inputs are not connected the object appears with the corresponding default parameters that have been entered in the mask designer. Otherwise the input signal from the function block overwrites the according setting from the parameter dialog.

Visualization:

The colored highlight in the function block indicates, whether a HMI object is assigned or not.

Comment:

The data type of the inputs Values, YMin and YMax is set by connecting any one of them.